#
# This is the SPEC file for creating binary and source RPMs for the Dom0.
#
#
# The Qubes OS Project, http://www.qubes-os.org
#
# Copyright (C) 2010  Joanna Rutkowska <joanna@invisiblethingslab.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
#

Name:		qubes-gui-daemon
Version:	4.1.5
Release:	1%{dist}
Summary:	The Qubes GUI virtualization

Group:		Qubes
Vendor:		Invisible Things Lab
License:	GPL
URL:		http://www.qubes-os.org

Requires:	xorg-x11-server-Xorg
Requires:	service(graphical-login)
Requires:	libconfig
Requires:	qubes-libvchan-xen
Requires:   python%{python3_pkgversion}-xcffib
Requires:   qubes-utils >= 3.1.0
Requires:   qubes-core-qrexec >= 4.1.5
Requires:   qubes-utils >= 4.1.4
Requires:   socat

BuildRequires:  python%{python3_pkgversion}-devel
BuildRequires:  pulseaudio-libs-devel
BuildRequires:	libXt-devel
BuildRequires:	libXext-devel
BuildRequires:	libXrandr-devel
BuildRequires:	libconfig-devel
BuildRequires:	libpng-devel
BuildRequires:	libnotify-devel
BuildRequires:	xen-devel
BuildRequires:	qubes-db-devel
BuildRequires:	help2man
BuildRequires:	gcc
BuildRequires:	qubes-core-libs-devel >= 1.6.1
BuildRequires:	qubes-core-libs
BuildRequires:	qubes-gui-common-devel >= 3.2.0
BuildRequires:	qubes-libvchan-xen-devel

Source0: %{name}-%{version}.tar.gz

%description
The Qubes GUI virtualization infrastructure that needs to be installed in GuiVM.

%package -n qubes-gui-dom0
Summary:    Dom0 part of Qubes GUI
# For now require also gui-daemon in dom0, when dropping GUI in dom0, this
# dependency should be dropped
Requires:   qubes-gui-daemon
# Pull also audio packages for easier upgrade
Requires:   qubes-audio-daemon
Requires:   qubes-audio-dom0
Requires:	qubes-core-dom0 >= 4.1.1
Requires:   python%{python3_pkgversion}-setuptools

%description -n qubes-gui-dom0
Dom0 files for Qubes GUI virtualization. This include core-admin extension,
policy files etc.

%package -n qubes-audio-daemon
Summary:	The Qubes AUDIO virtualization
Requires:	pulseaudio-libs
Requires:	pulseaudio
Requires:	libconfig
Requires:	qubes-libvchan-xen
Requires:   qubes-utils >= 3.1.0
Requires:   python%{python3_pkgversion}-pydbus

%description -n qubes-audio-daemon
The Qubes AUDIO virtualization infrastructure that needs to be installed in AudioVM.

%package -n qubes-audio-dom0
Summary:    Dom0 part of Qubes AUDIO
Requires:	qubes-core-dom0 >= 1.3.14
Requires:   python%{python3_pkgversion}-setuptools

%description -n qubes-audio-dom0
Dom0 files for Qubes AUDIO virtualization. This include core-admin extension,
policy files etc.

%prep
%setup -q

%build
%{?set_build_flags}
make clean
make all BACKEND_VMM=xen

%py3_build

%pre

%install
rm -rf $RPM_BUILD_ROOT
%make_install
%py3_install

%triggerin -- xorg-x11-server-Xorg
ln -sf /usr/bin/X-wrapper-qubes /usr/bin/X

%postun
if [ "$1" = 0 ] ; then
	# no more packages left
    ln -sf /usr/bin/Xorg /usr/bin/X
fi

%clean
rm -rf $RPM_BUILD_ROOT
rm -f %{name}-%{version}

%files
%defattr(-,root,root,-)
%attr(4750,root,qubes) /usr/bin/qubes-guid
%{_mandir}/man1/qubes-guid.1.gz
/usr/bin/X-wrapper-qubes
%{_libdir}/qubes-gui-daemon/shmoverride.so
%config(noreplace) %{_sysconfdir}/qubes/guid.conf
/etc/xdg/autostart/qubes-screen-layout-watches.desktop
/etc/xdg/autostart/qubes-icon-receiver.desktop
/etc/X11/xinit/xinitrc.d/qubes-localgroup.sh
/usr/libexec/qubes/watch-screen-layout-changes
/usr/lib/qubes/icon-receiver
%config %{_sysconfdir}/qubes-rpc/qubes.WindowIconUpdater
%config %{_sysconfdir}/qubes/rpc-config/qubes.WindowIconUpdater

%files -n qubes-audio-daemon
/usr/bin/pacat-simple-vchan
/etc/qubes-rpc/qubes.AudioInputEnable
/etc/qubes-rpc/qubes.AudioInputDisable

%files -n qubes-gui-dom0
%config(noreplace) %{_sysconfdir}/qubes-rpc/policy/qubes.ClipboardPaste
%config(noreplace) %{_sysconfdir}/qubes-rpc/policy/qubes.WindowIconUpdater

%files -n qubes-audio-dom0
%{python3_sitelib}/qubesguidaemon-*.egg-info
%{python3_sitelib}/qubesguidaemon

%changelog
* Fri Apr 10 2020 Qubes OS Team <qubes-devel@googlegroups.com>
- For complete changelog see: https://github.com/QubesOS/qubes-gui-daemon

* Fri Apr 10 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 3ed85ac
- version 4.1.5

* Fri Apr 10 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 149c263
- travis: add CentOS 7

* Fri Apr 10 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - b32a98f
- Revert "Currently disable failing builds for CentOS 7"

* Thu Apr 09 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 5079096
- rpm: require new enough qubes-core-dom0

* Thu Apr 09 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - f44e916
- Update core-admin extension for new audio-input control mechanism

* Thu Apr 09 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 742876e
- rpm: use rpm-build provided CFLAGS for pacat-simple-vchan

* Thu Apr 09 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 2d86b15
- pulse: add qrexec services to control audio-input in another VM

* Thu Apr 09 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - de42489
- pulse: replace dbus control with QubesDB + local socket

* Thu Apr 09 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 576ce38
- rpm: pull in audio packages on dom0 upgrade

* Thu Apr 09 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - aa84bf6
- pulse: fix compiler warning

* Mon Apr 06 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - dff304a
- pulse: create pidfile

* Sun Apr 05 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - ad3b39c
- pulse: periodically check if vchan connection is alive

* Sun Apr 05 2020 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - baceb86
- Currently disable failing builds for CentOS 7

* Sat Apr 04 2020 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 7f767db
- spec: put audio part in subpackage

* Sat Apr 04 2020 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 9186ef9
- xside: drop related pulseaudio (done in qvm-start-daemon)

* Thu Apr 02 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 6e35ed4
- Define supported protocol version

* Tue Mar 31 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 05498da
- icon-receiver: handle app.domains updates

* Tue Mar 31 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - ddc3377
- icon-receiver: use logging

* Tue Mar 31 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 4f67989
- Add dependencies for qubes.WindowIconUpdater

* Tue Mar 31 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - bc7a21c
- qubes.WindowIconUpdater: use wait-for-session

* Tue Mar 31 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 265a822
- Convert qubes.WindowIconUpdater to a socket service

* Mon Mar 30 2020 M. Vefa Bicakci <m.v.b@runbox.com> - 8d2f822
- xside: Introduce override_redirect protection

* Fri Mar 27 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - de10209
- Support MSG_CURSOR

* Wed Mar 25 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 24e947b
- shmoverride: handle Xorg crash leaving shm.id file

* Fri Mar 20 2020 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 107bb5c
- qubes-release: define it in xside.h

* Wed Mar 18 2020 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 7bf2659
- gui-daemon: set qubes-keyboard only in dom0

* Sun Mar 15 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - e933eb2
- version 4.1.4

* Sun Mar 08 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - b5369a1
- Fix tray icon coloring code - do not crop/dislocate icon fragments

* Mon Feb 24 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 697f679
- Make qubes.WindowIconUpdater a proper script

* Mon Feb 24 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 8faeeee
- Make files in qubes-rpc executable

* Sat Jan 11 2020 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - e35eed9
- travis: switch to dom0 Fedora 31

* Sun Jan 05 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - e8c1997
- version 4.1.3

* Mon Nov 25 2019 Snowy Marmot <marmot1791@protonmail.com> - a3b667b
- Review and fix spelling

* Mon Nov 25 2019 Snowy Marmot <marmot1791@protonmail.com> - faab21a
- Add exmaples/comments to guid.conf

* Sat Oct 19 2019 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 5855f30
- travis: switch to bionic

* Mon Jun 10 2019 xaki23 <tvguho-knxv23-tct.e23f2f1b@hashmail.org> - ec0c0d0
- allow domid 0 as target

* Sat Apr 20 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 0d5d139
- version 4.1.2

* Mon Apr 01 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 8982b73
- Fix setting shmoverride.so localtion

* Fri Mar 29 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 4ef6690
- version 4.1.1

* Sat Mar 09 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 05afcca
- rpm: use %{python3_pkgversion} to make it CentOS compatible

* Fri Mar 08 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - f6b25d6
- xside: send old MSG_CLIPBOARD_DATA if agent is old

* Fri Mar 08 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 99d6488
- xside: save agent protocol version

* Sat Mar 02 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - a029825
- version 4.1.0

* Sat Mar 02 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 5257cc7
- travis: add VM packaging tests

* Sat Mar 02 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - ceb4ebd
- debian: initial Debian packaging

* Sat Mar 02 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 82088aa
- Move shmoverride.so to subdirectory

* Sat Mar 02 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 878258e
- Fix shmoverride link flags

* Sat Mar 02 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - b31fbed
- Fix file permissions - drop executable bit where not needed

* Sat Mar 02 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 8130273
- Fix a bunch of compiler warnings

* Sat Mar 02 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - e64bac0
- makefile: remove obsolete rpm building rules

